/*****************************************************************/
/*                                                               */
/*   inp Library  ver 0.81                                       */
/*                                                               */
/*   written by sentaro21                                        */
/*                                                               */
/*****************************************************************/
/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <fxlib.h>
#include "fx_syscall.h"
#include "inp.h"
#include "Fkey.h"

//----------------------------------------------------------------------------------------------
int charX=0,charY=0;

int InputChar() {
	unsigned char
	CHAR[128]={' ', '!', '"', '#', '$', '%', '&',0x27, '(', ')', '*', '+', ',', '-', '.', '/',
	           '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
	           '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
	           'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[',0x5C, ']', '^', '_',
	           0x60,'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
	           'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', 0xD8,
	           0x01,0x03,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0F,0x10,0x11,0x12,0x13,0xC2,0xC3,
	           0x1A,0x1B,0x1C,0x1D,0x1E,0x1F,0x86,0x87,0x8C,0x9C,0xAC,0xBC,0xB5,0xBB,0xCB,0xCC};

	int cont=1, cx,cy, C=0;
	unsigned int key;

	SaveDisp(SAVEDISP_PAGE1);		// --------
	Bdisp_AllClr_DDVRAM();

	for (cy=0; cy<8; cy++) {
		for (cx=0; cx<16; cx++) {
			locate(cx+3,cy+1); PrintC( CHAR+ cx + cy*16 );
		}
	}
	
	while (cont) {
		Cursor_SetPosition(charX+2,charY+0);
	
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_AC:
				RestoreDisp(SAVEDISP_PAGE1);	// --------
				return -1;	// input cancel
				break;
			case KEY_CTRL_EXIT:
				RestoreDisp(SAVEDISP_PAGE1);	// --------
				return -1;	// input cancel
				break;
			case KEY_CTRL_EXE:
				cont=0;
				break;
			case KEY_CTRL_LEFT:
				charX-=1; if ( charX <  0 ) charX=15;
				break;
			case KEY_CTRL_RIGHT:
				charX+=1; if ( charX > 15 ) charX= 0;
				break;
			case KEY_CTRL_UP:
				charY-=1; if ( charY <  0 ) charY= 7;
				break;
			case KEY_CTRL_DOWN:
				charY+=1; if ( charY >  7 ) charY= 0;
				break;
			default:
				break;
		}
	}
	
	RestoreDisp(SAVEDISP_PAGE1);	// --------
	return ( CHAR[ charX + charY*16 ] );
}


//----------------------------------------------------------------------------------------------

int InputStrSub(int x, int y, int width, int csrX, char* buffer, char SPC, int rev_mode, int float_mode, int exp_mode, int alpha_mode) {
	char buffer2[32];
	int i,j;
	unsigned int key=0;
	int numX=csrX, lowercase=0, CursorStyle;
	int cont=1;

	for(i=0; i<22; i++) buffer2[i]=buffer[i]; // backup
	for(i=csrX; i<width; i++ ) buffer[i]=SPC; // character ( not entered area )

	Cursor_SetFlashMode(1);			// cursor flashing on
	if (Cursor_GetFlashStyle()<0x6)	Cursor_SetFlashOn(0x0);		// insert mode cursor 
		else 						Cursor_SetFlashOn(0x6);		// overwrite mode cursor 

	while (cont) {
		buffer[width]='\0';
		if ( rev_mode )	{ locate(x,y); PrintRev((unsigned char*)buffer); }
		 		else	{ locate(x,y); Print((unsigned char*)buffer); }
		if ( alpha_mode ) if ( lowercase ) Fkey_dispN(4,"a<>A"); else Fkey_dispN(4,"A<>a");
		if ( alpha_mode ) Fkey_dispR(5,"CHAR");

		CursorStyle=Cursor_GetFlashStyle();
		if ( ( CursorStyle==0x3 ) && lowercase != 0 ) Cursor_SetFlashOn(0x4);		// lowercase  cursor
		if ( ( CursorStyle==0x4 ) && lowercase == 0 ) Cursor_SetFlashOn(0x3);		// upperrcase cursor
		if ( ( CursorStyle==0x9 ) && lowercase != 0 ) Cursor_SetFlashOn(0xA);		// lowercase  cursor
		if ( ( CursorStyle==0xA ) && lowercase == 0 ) Cursor_SetFlashOn(0x9);		// upperrcase cursor
		Cursor_SetPosition(x+csrX-1,y-1);
	
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_AC:
				csrX=0; numX=0;
				for(i=csrX; i<width; i++) buffer[i]=SPC;
				break;
			case KEY_CTRL_EXIT:
				cont=0;
				Cursor_SetFlashMode(0);		// cursor flashing off
				if ( alpha_mode ) { Fkey_Clear(4); Fkey_Clear(5); }
				for(i=0; i<22; i++) buffer[i]=buffer2[i]; // restore
				return -1;	// input cancel
				break;
			case KEY_CTRL_EXE:
				cont=0;
				break;
			case KEY_CTRL_DEL:
				if (csrX==0) {
					if (numX>0) {
						for(i=csrX; i<numX; i++) buffer[i]=buffer[i+1];
						numX--;
					}
				}
				if (csrX>0) {
					if (CursorStyle<0x6) {	// insert mode
						for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
						csrX--;
						numX--;
					}
					else {								// overwrite mode
						if (csrX==numX) {
							for(i=csrX-1; i<width; i++) buffer[i]=buffer[i+1];
							csrX--;
							numX--;
						}
						else {
							for(i=csrX  ; i<width; i++) buffer[i]=buffer[i+1];
							numX--;
						}
					}
				}
				buffer[numX]=SPC;
				break;
			case KEY_CTRL_LEFT:
				if (csrX>0) {
					csrX--;
				}
				break;
			case KEY_CTRL_RIGHT:
				if (csrX<numX) {
					csrX++;
				}
				break;
			case KEY_CTRL_UP:
					csrX=0; 
				break;
			case KEY_CTRL_DOWN:
					csrX=numX;
				break;
			case KEY_CTRL_F5:
				lowercase=1-lowercase;
				break;
			case KEY_CTRL_F6:
				key=InputChar();
				break;
			default:
				break;
		}
		if (
		   ( KEY_CHAR_0 <= key  ) && ( key <= KEY_CHAR_9     ) ||
		   ( float_mode && ( key == KEY_CHAR_DP ) ) || ( key == KEY_CHAR_MINUS ) || ( key == KEY_CHAR_PMINUS ) || ( key == KEY_CHAR_PLUS ) ||
		   ( float_mode && exp_mode && ( key == KEY_CHAR_EXP )  ) ||
		   ( alpha_mode && ( 0x1A <= key  ) && ( key <= 0x7E ) ) ||
		   ( alpha_mode && ( 0x07 <= key  ) && ( key <= 0x0D ) ) ||
		   ( alpha_mode && ( 0x0F <= key  ) && ( key <= 0x13 ) ) ||
		   ( alpha_mode && ( 0x01 == key  ) ) ||
		   ( alpha_mode && ( 0x03 == key  ) ) ||
		   ( alpha_mode && ( 0x86 == key  ) ) ||
		   ( alpha_mode && ( 0x87 == key  ) ) ||
		   ( alpha_mode && ( 0x8C == key  ) ) ||
		   ( alpha_mode && ( 0x9C == key  ) ) ||
		   ( alpha_mode && ( 0xAC == key  ) ) ||
		   ( alpha_mode && ( 0xBC == key  ) ) ||
		   ( alpha_mode && ( 0xB5 == key  ) ) ||
		   ( alpha_mode && ( 0xBB == key  ) ) ||
		   ( alpha_mode && ( 0xD8 == key  ) ) ||
		   ( alpha_mode && ( 0xC2 == key  ) ) ||
		   ( alpha_mode && ( 0xC3 == key  ) ) ||
		   ( alpha_mode && ( 0xCB == key  ) ) ||
		   ( alpha_mode && ( 0xCC == key  ) ) ||
		   ( alpha_mode && ( 0xCD == key  ) ) ||
		   ( alpha_mode && ( KEY_CHAR_MULT == key  ) ) ||
		   ( alpha_mode && ( KEY_CHAR_DIV  == key  ) ) ||
		   ( alpha_mode && ( KEY_CHAR_POW  == key  ) )
		   ) {
			if ( lowercase  && ( 'A' <= key  ) && ( key <= 'Z' ) ) key+=('a'-'A');
			if ( key == KEY_CHAR_PLUS  )  key='+';
			if ( key == KEY_CHAR_MINUS )  key='-';
			if ( key == KEY_CHAR_PMINUS ) key='-';
			if ( key == KEY_CHAR_EXP )  { key='e'; if ( alpha_mode ) key=0x0F; }
			if ( key == KEY_CHAR_MULT )   key=0xA9; // *
			if ( key == KEY_CHAR_DIV )    key=0xB9; // /
			if ( key == KEY_CHAR_POW )    key=0x5E; // ^
			
			if (csrX<width) {
				if (csrX<numX) {
					if (CursorStyle<0x6) {
						if (numX<width) {		// insert mode
							for(i=width; i>csrX; i--) buffer[i]=buffer[i-1];
							buffer[csrX]=key;
							numX++;
							csrX++;
						}
					}
					else {				// overwrite mode
							buffer[csrX]=key;
							if (csrX<width) csrX++;
					}
				}
				else {					// new
					buffer[csrX]=key;
					csrX++; if (csrX>numX) numX=csrX;
				}
			}
		}
	}

	Cursor_SetFlashMode(0);		// cursor flashing off
	if ( alpha_mode ) { Fkey_Clear(4); Fkey_Clear(5); }
	
	buffer[numX]='\0';
	return ( 0 );	// Ok
}

//----------------------------------------------------------------------------------------------
void sprintG(char* buffer, double num, int width, int align_mode) {
	int i,w,adj,minus=0;
	double round_adj=0;
	char buffer2[32];
    
	if ( num < 0 ) minus=-1;
 	w=15; if ( w > width )  w=width;
	if ( ( 0.0001 <= fabs(num) ) && ( fabs(num) < pow(10,w+minus) ) ) {
		w = floor((log10(fabs(num)))) - minus;
		if ( 16 >= width ) w= w+(16-width);
		if ( w <=  0 ) sprintf(buffer,"%.14f",num);
		if ( w ==  1 ) sprintf(buffer,"%.13f",num);
		if ( w ==  2 ) sprintf(buffer,"%.12f",num);
		if ( w ==  3 ) sprintf(buffer,"%.11f",num);
		if ( w ==  4 ) sprintf(buffer,"%.10f",num);
		if ( w ==  5 ) sprintf(buffer,"%.9f",num);
		if ( w ==  6 ) sprintf(buffer,"%.8f",num);
		if ( w ==  7 ) sprintf(buffer,"%.7f",num);
		if ( w ==  8 ) sprintf(buffer,"%.6f",num);
		if ( w ==  9 ) sprintf(buffer,"%.5f",num);
		if ( w == 10 ) sprintf(buffer,"%.4f",num);
		if ( w == 11 ) sprintf(buffer,"%.3f",num);
		if ( w == 12 ) sprintf(buffer,"%.2f",num);
		if ( w == 13 ) sprintf(buffer,"%.1f",num);
		if ( w >= 14 ) sprintf(buffer,"%.0f",num);
	}
	else {
		adj = 1 - minus;
		if ( floor(log10(log10(fabs(num)))) >2 ) adj+=1;
		if ( width >= 20+adj ) sprintf(buffer,"%.15g",num);
		if ( width == 19+adj ) sprintf(buffer,"%.14g",num);
		if ( width == 18+adj ) sprintf(buffer,"%.13g",num);
		if ( width == 17+adj ) sprintf(buffer,"%.12g",num);
		if ( width == 16+adj ) sprintf(buffer,"%.11g",num);
		if ( width == 15+adj ) sprintf(buffer,"%.10g",num);
		if ( width == 14+adj ) sprintf(buffer,"%.9g",num);
		if ( width == 13+adj ) sprintf(buffer,"%.8g",num);
		if ( width == 12+adj ) sprintf(buffer,"%.7g",num);
		if ( width == 11+adj ) sprintf(buffer,"%.6g",num);
		if ( width == 10+adj ) sprintf(buffer,"%.5g",num);
		if ( width ==  9+adj ) sprintf(buffer,"%.4g",num);
		if ( width ==  8+adj ) sprintf(buffer,"%.3g",num);
		if ( width ==  7+adj ) sprintf(buffer,"%.2g",num);
		if ( width <   7+adj ) sprintf(buffer,"%.1g",num);
	}

	if ( ( strchr(buffer,'.') != '\0' ) && ( strchr(buffer,'e') == '\0' ) ) {
		i=strlen(buffer)-1;
		while ( buffer[i]=='0' ) buffer[i--]='\0';		// 1.234500000  zero cut
		if ( buffer[i]=='.' ) buffer[i]='\0';
	}

	if ( align_mode == RIGHT_ALIGN ) {
		for(i=0; i<22; i++) buffer2[i]=buffer[i]; // 
		w=strlen(buffer2);
		if ( w < width ) {
			for ( i=1; i<=w; i++)
			 buffer2[width-i]=buffer2[w-i];
			for ( i=0; i<width-w; i++) buffer2[i]=' ';
		}
		for(i=0; i<22; i++) buffer[i]=buffer2[i]; // 
	}
	
	buffer[width]='\0';
	return ;
}

//----------------------------------------------------------------------------------------------
double InputNumD(int x, int y, int width, double defaultNum, char SPC, int rev_mode, int float_mode, int exp_mode) {		// 0123456789.(-)exp
	char buffer[32];
	int i,csrX=0;

	buffer[csrX]='\0';
	if ( defaultNum != 0 ) {
		sprintG(buffer, defaultNum, width, LEFT_ALIGN);
		csrX=strlen(buffer);
	}
	if ( InputStrSub( x, y, width, csrX, buffer, SPC, rev_mode, float_mode, exp_mode, ALPHA_OFF) ) return (defaultNum);  // exit
	return atof( buffer );
}


char* InputStr(int x, int y, int width, char* buffer, char SPC, int rev_mode) {		// ABCDEF0123456789.(-)exp
	int i,csrX=0;

	buffer[width]='\0';
	csrX=strlen(buffer);
	if ( InputStrSub( x, y, width, csrX, buffer, SPC, rev_mode, FLOAT_ON, EXP_ON, ALPHA_ON) ) buffer[csrX]='\0';  // exit
	return ( buffer );
}


